<?php

#### inline markups ####
## '/cite/'
Markup("'/","<'''''","/'\/(.*?)\/'/",
    '<tbook:visual markup=\'sl\'>$1</tbook:visual>');

## '@keyboard@'
Markup("'@","<'''''","/'@(.*?)@'/",
    '<tbook:visual markup=\'sf\'>$1</tbook:visual>');

## marginal notes
Markup("{=",'inline',"/{=(.*?)(?:\|\s*(.*?))?=}/",
    '<tbook:mnote>$1</tbook:mnote>');

## ';small caps;'
Markup("';","<'''''","/';(.*?);'/",
    '<tbook:visual markup=\'sc\'>$1</tbook:visual>');

## LaTeX entity ligatures
Markup('latex', "<'^", '/([`\/])?\\b(La[Tt]e[Xx])\\b/e',
  "('$1'=='/') ? '$1$2' : Keep('&LaTeX;');");
Markup('tech',"<'^",'/(\\/)?\\bTeX\\b/e',"'$1' ? '$1TeX' : Keep('&TeX;');");
Markup('bibtex',"<'^",'/(\\/)?\\b(Bib[Tt]e[Xx])\\b/e',
  "'$1' ? '$1$2' : 'B\'-IB-\''.Keep('&TeX;')");
$EnableTitleLatex = true;

## Z; dropcaps markup
Markup('A;','block','/^([[:upper:]]);(([^;&]*(&[^;]+;)*)*);(.*)$/',
    '<:block><tbook:p skip="big"><tbook:lettrine initial=\'$1\'>$2</tbook:lettrine>$5</tbook:p>');

## [^footnote text^] and [^#^] to list footnotes
Markup("[^",'>links','/\[\^(.*?)\^\]/','<tbook:footnote>$1</tbook:footnote>');
Markup("^[^",'<[^','/^\[\^#\^\]$/','');

## figure captions
Markup('fig','<links',
"/^=figure\s+((?:\[\[)?.*?$ImgExtPattern\"([^\"]*)\"(?:\]\])?)\s*(.*?)$/e",
    "'<:block><tbook:figure>'.PSS('$1').'<tbook:caption>'.
    (('$3'=='') ? PSS('$2') : PSS('$3')).'</tbook:caption></tbook:figure>'");


## =| centred text
Markup('^=|','block','/^=\|(.*)$/',
    "<:block><tbook:p align='center'>$1</tbook:p>");

## !run-in heads!and text
Markup('^!!','inline','/^!([^!]+)!/',
   '<tbook:visual markup=\'sf\'><tbook:visual markup=\'bf\'><tbook:style size=\'-1\'>$1. </tbook:style></tbook:visual></tbook:visual>');


## :+ for multiple <dd> per <dt> and multipar item lists
Markup(':+','<block','/^(:+.*?:)((?:.*?:\+.*?)+)$/e',
    "PSS('$1').'<tbook:p>'.str_replace(':+','</tbook:p><tbook:p>',PSS('$2')).'</tbook:p>'");
Markup(':+*','<block','/^([#*]+)((?:.*?:\+.*?)+)$/e',
    "PSS('$1').'<tbook:p>'.str_replace(':+','</tbook:p><tbook:p>',PSS('$2')).'</tbook:p>'");
Markup(':+P','>:+*','/:\+/',
    '<tbook:newline vspace="0.3em" /><tbook:hspace dim="*1em" />');


## equations
$LatexrenderUrlFmt =
    "<tbook:latex kind=\"\$LinkClass\" code=\"\$LinkTitle\" />";
Markup('latexeq','<latexdm','/\{\$\s*([A-Za-z][-.:\\w]*)\s*,(.*?)\$\}/e',
    "LatexRWiki('equation','$2').'<tbook:wrap id=\"$1\" />'");
Markup('eqref','>latexr','/(EQ)\(([A-Za-z][-.:\\w]*)\)/e',
    "Keep(TBFigureRef(\$pagename,'$1','$2'),'L')");
Markup('tbwrapeq','>style',
      '/(<tbook:latex[^\/]*)\s*\/><tbook:wrap\s+(id=[^>]*>)/','$1 $2');

## figure and table references
SDV($ReferencePrefixFmt, array('EQ' => '$[equation]', 'FIG' => '$[figure]', 
    'TAB' => '$[table]'));
$FigureReferenceFmt = '<tbook:ref refid="$LinkID">$LinkText</tbook:ref>';
Markup('figref','inline','/(FIG|TAB)\(([A-Za-z][-.:\\w]*)\)/e',
    "Keep(TBFigureRef(\$pagename,'$1','$2'),'L')");

function TBFigureRef($pagename, $kind, $id) {
  global $ReferencePrefixFmt, $FigureReferenceFmt, $ReferenceList;
  $ref = isset($ReferenceList[$id]) ? " ($ReferenceList[$id])" : '';
  $txt = FmtPageName($ReferencePrefixFmt[$kind], $pagename);
  return str_replace(array('$LinkID', '$LinkText'), array($id, $txt), 
    $FigureReferenceFmt) . $ref;
}

#Markup('latexr','inline','/\{\$(.*?)\$\}/e',
#   "'<tbook:latex code=\'$'.Keep(trim('$1')).'$\'></tbook:latex>'");
#   "'<tbook:m>'.Keep(trim('$1')).'</tbook:m>'");
#  "MimetexTbook('$1')");
#
#function MimetexTbook($tex) {
#  global $MimetexCmd;
#  $tex = trim($tex);
#  return Keep("<tbook:graphics kind=\"bitmap\" file=\"$MimetexCmd?$tex\" />");
#} 

## (:markup:) that excludes heading markup examples
function TbookHMarkupMarkup($pagename, $lead, $texta, $textb) {
  return "$lead<:block>" .
    Keep("<tbook:group class='frame'><tbook:verbatim>" . wordwrap($texta, 70) . 
    "</tbook:verbatim><tbook:hr style='dotted' />") .
    "\n$textb\n(:divend:)</tbook:group>\n";
}

Markup('`markup','<markup',
  "/(^|\\(:nl:\\))\\(:markup:\\)[^\\S\n]*\\[([=@])((?:\n`\\.!+.*?)+)\\2\\]/seim",
  "TbookHMarkupMarkup(\$pagename, '$1', PSS(str_replace('`.','','$3')), PSS('$3'))");

## (:notice:) markup for conditional notices
$Conditions['exists'] = "MultiPageExists(\$condparm,\$pagename)";
Markup('notice', 'block', '/^\(:notice\s+(.*?)\s*:\)$/',
    "<:block><tbook:notice kind='$1'>");
Markup('noticeend', 'block', '/^\(:noticeend:\)$/', "<:block></tbook:notice>");

function MultiPageExists($args, $pagename) {
  foreach(explode(' ', $args) as $v)
    if (PageExists(FmtPageName($v, $pagename))) return true;
  return false;
}

?>